Subject: bug#62153: closed (Re: [bug#62153] [PATCH 5/5] scripts: system: Build layered images.)

From: [email-masked] (GNU bug Tracking System)
Date: Tue, 09 Jan 2024 13:00:02 +0000

Your bug report

#62153: [PATCH 0/2] Add Docker layered image for pack and system

which was filed against the guix-patches package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
62153: https://debbugs.gnu.org/cgi/bugreport.cgi?bug=62153
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: [bug#62153] [PATCH 5/5] scripts: system: Build layered images.
From: Oleg Pykhalov <[email-masked]>
To: Ludovic Courtès <[email-masked]>
Cc: Josselin Poiret <[email-masked]>, Simon Tournier <[email-masked]>, Mathieu Othacehe <[email-masked]>, Tobias Geerinckx-Rice <[email-masked]>, Ricardo Wurmus <[email-masked]>, [email-masked], Christopher Baines <[email-masked]>
Date: Tue, 09 Jan 2024 15:58:58 +0300
List-Id: <debbugs-submit.debbugs.gnu.org>

Hello Ludovic,

Ludovic Courtès <[email-masked]> writes:

>> Other than the few cosmetic remarks, the series looks great. I tested
>> producing multi-layers pack and images with success.
>>
>> You may want to wait for Ludo's opinion as a reviewer of the v4, but as
>> far as I am concerned, I think that you can directly proceed with the
>> cosmetic issues fixed.
>
> I haven’t been able to test it yet, but I agree with Mathieu’s
> suggestions and I agree that you can proceed with this small fixes.
>
> As a bonus, consider adding an entry in ‘etc/news.scm’: it’s definitely
> news-worthy!

All Mathieu's suggestions applied, etc/news.scm from v4 slightly
modified accordingly.  Everything pushed to master.

Thanks everyone for helping adding this feature.

Oleg.

Subject: [PATCH 0/2] Add Docker layered image for pack and system
From: Oleg Pykhalov <[email-masked]>
To: [email-masked]
Cc: Oleg Pykhalov <[email-masked]>
Date: Mon, 13 Mar 2023 03:30:12 +0300
List-Id: <debbugs-submit.debbugs.gnu.org>

Hi Guix,

This patch series add to 'guix pack' and 'guix system image' formats with a
layered Docker image, which dicreases images size by sharing same layers on a
host.

The folling commands show an example for new image formats:

./pre-inst-env guix system image --image-type=docker-layered config.scm
docker load -i result

./pre-inst-env guix pack -f docker --entry-point=bin/bash -S /bin=bin bash hello
docker load -i result

The folloing tests passed:

make check-channel-news
make check TESTS="tests/pack.scm"
make check-system TESTS="docker-system docker-layered-system"

The gnu/packages/aux-files/python/stream-layered-image.py Python script is a
copy of github.com/NixOS/nixpkgs/pkgs/build-support/docker/stream_layered_image.py
with only a simple replacement "/nix" to "/gnu" string.

Oleg Pykhalov (2):
  guix: docker: Build layered image.
  news: Add entry for the new 'docker-layered' distribution format.

 Makefile.am                                   |   3 +-
 doc/guix.texi                                 |  16 +-
 etc/news.scm                                  |  38 ++
 gnu/image.scm                                 |   3 +-
 .../aux-files/python/stream-layered-image.py  | 391 ++++++++++++++++++
 gnu/system/image.scm                          |  84 +++-
 gnu/tests/docker.scm                          |  20 +-
 guix/docker.scm                               | 182 ++++++--
 guix/scripts/pack.scm                         | 103 +++--
 guix/scripts/system.scm                       |  11 +-
 tests/pack.scm                                |  48 +++
 11 files changed, 813 insertions(+), 86 deletions(-)
 create mode 100644 gnu/packages/aux-files/python/stream-layered-image.py

base-commit: 60a211ec705ac98483d76da7f2523f2b8966343a
-- 
2.38.0